Nume=("nop_0"  ,"nop_1"  ,"or1"    ,"sh1"    , #0x00
      "zero"   ,"if_cz"  ,"sub_ab" ,"sub_ac" , #0x04
      "inc_a"  ,"inc_b"  ,"dec_c"  ,"inc_c"  , #0x08
      "push_ax","push_bx","push_cx","push_dx", #0x0C
      "pop_ax" ,"pop_bx" ,"pop_cx" ,"pop_dx" , #0x10
      "jmp"    ,"jmpb"   ,"call"   ,"ret"    , #0x14
      "mov_cd" ,"mov_ab" ,"mov_iab","adr"    , #0x18
      "adrb"   ,"adrf"   ,"mal"    ,"divide" ) #0x1A
def setCode(NCode):
    global Nume; N=len(Nume)
    for i in range(N):
        if NCode==Nume[i]: return i
    return 0xFE
def assemble(Str):
    N=len(Str);Code=[0 for i in range(N)]
    for i in range(N):
        C=setCode(Str[i])
        if C==0xFE:
            print("*** Assemble Error Code No. %d"% i, Str[i])
        Code[i]=C
    return Code
def printAss(Code,Str):
    print("相対アドレス Code ニーモニック")
    print("------------------------------")
    for i in range(len(Code)):
        print("%8d      %02X   "%(i,Code[i]),Str[i])
def stringCode(CD):#■バイナリ・コードをニーモニック・コードに変換
    if CD<0 or CD>= len(Nume): return " "*8
    S=Nume[CD]
    return " "*(8-len(S))+S
ancestor=("nop_1","nop_1","nop_1","nop_1",#母コード開始ブロック
          "zero","or1","sh1","sh1","mov_cd",#cx=0;cx^=1;cx>>=2;dx=cx
          "adrb","nop_0","nop_0","nop_0","nop_0",# ax=1111アドレス(前方)
          "sub_ac","mov_ab",                     # ax-=cx;bx=ax
          "adrf","nop_0","nop_0","nop_0","nop_1",# ax=1110アドレス(後方)
          "inc_a",                               # inc ax
          "sub_ab",                              # ax=ax-bx
          "nop_1","nop_1","nop_0","nop_1",# 1101:
          "mal","call","nop_0","nop_0","nop_1","nop_1",# Call CopyProc
          "divide",  # 娘コード切り離し(tiny Tierraではここで終了)
          "jmp",     # jmp 1101(0010の相補）tiny Tierraでは無視)
          "nop_0","nop_0","nop_1","nop_0",# 0010:
          "if_cz",                        # 区切りのためのダミー命令
          "nop_1","nop_1","nop_0","nop_0",# CopyProc 開始ブロック
          "push_ax","push_bx","push_cx",  #     レジスタの退避
          "nop_1","nop_0","nop_1","nop_0",# 1010: 
          "mov_iab","dec_c",              #     mem[ax]=mem[bx]
          "if_cz","jmp",                  #     if cx==0:jmp 1011
          "nop_0","nop_1","nop_0","nop_0",# 0100:
          "inc_a","inc_b",                #     inc ax; inc bx
          "jmp", "nop_0","nop_1","nop_0","nop_1","if_cz",# jmp 1010
          "nop_1","nop_0","nop_1","nop_1",# 1011:
          "pop_cx","pop_bx", "pop_ax",    #     レジスタ復帰
          "ret",                          #     return
          "nop_1","nop_1","nop_1","nop_0", "if_cz")#Code End Block
def getAncestor(): global ancestor; return ancestor 
